devtools: enable more config options in build test
[dpdk.git] / devtools / test-meson-builds.sh
1 #! /bin/sh -e
2 # SPDX-License-Identifier: BSD-3-Clause
3 # Copyright(c) 2018 Intel Corporation
4
5 # Run meson to auto-configure the various builds.
6 # * all builds get put in a directory whose name starts with "build-"
7 # * if a build-directory already exists we assume it was properly configured
8 # Run ninja after configuration is done.
9
10 # set pipefail option if possible
11 PIPEFAIL=""
12 set -o | grep -q pipefail && set -o pipefail && PIPEFAIL=1
13
14 srcdir=$(dirname $(readlink -f $0))/..
15 . $srcdir/devtools/load-devel-config
16
17 MESON=${MESON:-meson}
18 use_shared="--default-library=shared"
19 builds_dir=${DPDK_BUILD_TEST_DIR:-.}
20
21 if command -v gmake >/dev/null 2>&1 ; then
22         MAKE=gmake
23 else
24         MAKE=make
25 fi
26 if command -v ninja >/dev/null 2>&1 ; then
27         ninja_cmd=ninja
28 elif command -v ninja-build >/dev/null 2>&1 ; then
29         ninja_cmd=ninja-build
30 else
31         echo "ERROR: ninja is not found" >&2
32         exit 1
33 fi
34 if command -v ccache >/dev/null 2>&1 ; then
35         CCACHE=ccache
36 else
37         CCACHE=
38 fi
39
40 default_path=$PATH
41 default_pkgpath=$PKG_CONFIG_PATH
42 default_cppflags=$CPPFLAGS
43 default_cflags=$CFLAGS
44 default_ldflags=$LDFLAGS
45
46 load_env () # <target compiler>
47 {
48         targetcc=$1
49         export PATH=$default_path
50         export PKG_CONFIG_PATH=$default_pkgpath
51         export CPPFLAGS=$default_cppflags
52         export CFLAGS=$default_cflags
53         export LDFLAGS=$default_ldflags
54         unset DPDK_MESON_OPTIONS
55         command -v $targetcc >/dev/null 2>&1 || return 1
56         DPDK_TARGET=$($targetcc -v 2>&1 | sed -n 's,^Target: ,,p')
57         . $srcdir/devtools/load-devel-config
58 }
59
60 config () # <dir> <builddir> <meson options>
61 {
62         dir=$1
63         shift
64         builddir=$1
65         shift
66         if [ -f "$builddir/build.ninja" ] ; then
67                 # for existing environments, switch to debugoptimized if unset
68                 # so that ABI checks can run
69                 if ! $MESON configure $builddir |
70                                 awk '$1=="buildtype" {print $2}' |
71                                 grep -qw debugoptimized; then
72                         $MESON configure --buildtype=debugoptimized $builddir
73                 fi
74                 return
75         fi
76         options=
77         options="$options --werror -Dexamples=all"
78         options="$options --buildtype=debugoptimized"
79         for option in $DPDK_MESON_OPTIONS ; do
80                 options="$options -D$option"
81         done
82         options="$options $*"
83         echo "$MESON $options $dir $builddir"
84         $MESON $options $dir $builddir
85 }
86
87 compile () # <builddir>
88 {
89         builddir=$1
90         if [ -n "$TEST_MESON_BUILD_VERY_VERBOSE" ] ; then
91                 # for full output from ninja use "-v"
92                 echo "$ninja_cmd -v -C $builddir"
93                 $ninja_cmd -v -C $builddir
94         elif [ -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
95                 # for keeping the history of short cmds, pipe through cat
96                 echo "$ninja_cmd -C $builddir | cat"
97                 $ninja_cmd -C $builddir | cat
98         else
99                 echo "$ninja_cmd -C $builddir"
100                 $ninja_cmd -C $builddir
101         fi
102 }
103
104 install_target () # <builddir> <installdir>
105 {
106         rm -rf $2
107         echo "DESTDIR=$2 $ninja_cmd -C $1 install"
108         DESTDIR=$2 $ninja_cmd -C $1 install
109 }
110
111 build () # <directory> <target compiler> <meson options>
112 {
113         targetdir=$1
114         shift
115         targetcc=$1
116         shift
117         # skip build if compiler not available
118         command -v ${CC##* } >/dev/null 2>&1 || return 0
119         load_env $targetcc || return 0
120         config $srcdir $builds_dir/$targetdir $*
121         compile $builds_dir/$targetdir
122         if [ -n "$DPDK_ABI_REF_VERSION" ]; then
123                 abirefdir=${DPDK_ABI_REF_DIR:-reference}/$DPDK_ABI_REF_VERSION
124                 if [ ! -d $abirefdir/$targetdir ]; then
125                         # clone current sources
126                         if [ ! -d $abirefdir/src ]; then
127                                 git clone --local --no-hardlinks \
128                                         --single-branch \
129                                         -b $DPDK_ABI_REF_VERSION \
130                                         $srcdir $abirefdir/src
131                         fi
132
133                         rm -rf $abirefdir/build
134                         config $abirefdir/src $abirefdir/build $*
135                         compile $abirefdir/build
136                         install_target $abirefdir/build $abirefdir/$targetdir
137                         $srcdir/devtools/gen-abi.sh $abirefdir/$targetdir
138                 fi
139
140                 install_target $builds_dir/$targetdir \
141                         $(readlink -f $builds_dir/$targetdir/install)
142                 $srcdir/devtools/gen-abi.sh \
143                         $(readlink -f $builds_dir/$targetdir/install)
144                 $srcdir/devtools/check-abi.sh $abirefdir/$targetdir \
145                         $(readlink -f $builds_dir/$targetdir/install)
146         fi
147 }
148
149 if [ "$1" = "-vv" ] ; then
150         TEST_MESON_BUILD_VERY_VERBOSE=1
151 elif [ "$1" = "-v" ] ; then
152         TEST_MESON_BUILD_VERBOSE=1
153 fi
154 # we can't use plain verbose when we don't have pipefail option so up-level
155 if [ -z "$PIPEFAIL" -a -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
156         echo "# Missing pipefail shell option, changing VERBOSE to VERY_VERBOSE"
157         TEST_MESON_BUILD_VERY_VERBOSE=1
158 fi
159
160 # shared and static linked builds with gcc and clang
161 for c in gcc clang ; do
162         command -v $c >/dev/null 2>&1 || continue
163         for s in static shared ; do
164                 export CC="$CCACHE $c"
165                 build build-$c-$s $c --default-library=$s
166                 unset CC
167         done
168 done
169
170 # test compilation with minimal x86 instruction set
171 # Set the install path for libraries to "lib" explicitly to prevent problems
172 # with pkg-config prefixes if installed in "lib/x86_64-linux-gnu" later.
173 default_machine='nehalem'
174 ok=$(cc -march=$default_machine -E - < /dev/null > /dev/null 2>&1 || echo false)
175 if [ "$ok" = "false" ] ; then
176         default_machine='corei7'
177 fi
178 build build-x86-default cc -Dlibdir=lib -Dmachine=$default_machine $use_shared
179
180 c=aarch64-linux-gnu-gcc
181 # generic armv8a with clang as host compiler
182 export CC="clang"
183 build build-arm64-host-clang $c $use_shared \
184         --cross-file $srcdir/config/arm/arm64_armv8_linux_gcc
185 unset CC
186 # all gcc/arm configurations
187 for f in $srcdir/config/arm/arm64_[bdo]*gcc ; do
188         export CC="$CCACHE gcc"
189         build build-$(basename $f | tr '_' '-' | cut -d'-' -f-2) $c \
190                 $use_shared --cross-file $f
191         unset CC
192 done
193
194 # Test installation of the x86-default target, to be used for checking
195 # the sample apps build using the pkg-config file for cflags and libs
196 build_path=$(readlink -f $builds_dir/build-x86-default)
197 export DESTDIR=$build_path/install
198 # No need to reinstall if ABI checks are enabled
199 if [ -z "$DPDK_ABI_REF_VERSION" ]; then
200         install_target $build_path $DESTDIR
201 fi
202
203 load_env cc
204 pc_file=$(find $DESTDIR -name libdpdk.pc)
205 export PKG_CONFIG_PATH=$(dirname $pc_file):$PKG_CONFIG_PATH
206
207 # if pkg-config defines the necessary flags, test building some examples
208 if pkg-config --define-prefix libdpdk >/dev/null 2>&1; then
209         export PKGCONF="pkg-config --define-prefix"
210         for example in cmdline helloworld l2fwd l3fwd skeleton timer; do
211                 echo "## Building $example"
212                 $MAKE -C $DESTDIR/usr/local/share/dpdk/examples/$example clean all
213         done
214 fi